package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.utils.RequestUtil;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.UserCouponService;
import com.gxwebsoft.shop.entity.UserCoupon;
import com.gxwebsoft.shop.param.UserCouponParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.List;

/**
 * 控制器
 *
 * @author 科技小王子
 * @since 2025-12-03 13:47:42
 */
@Api(tags = "管理")
@RestController
@RequestMapping("/api/shop/user-coupon")
public class UserCouponController extends BaseController {
    @Resource
    private UserCouponService userCouponService;

    @ApiOperation("分页查询")
    @GetMapping("/page")
    public ApiResult<PageResult<UserCoupon>> page(UserCouponParam param) {
        // 使用关联查询
        return success(userCouponService.pageRel(param));
    }

    @ApiOperation("查询全部")
    @GetMapping()
    public ApiResult<List<UserCoupon>> list(UserCouponParam param) {
        // 使用关联查询
        param.setUserId(getLoginUserId());
        return success(userCouponService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userCoupon:list')")
    @ApiOperation("根据id查询")
    @GetMapping("/{id}")
    public ApiResult<UserCoupon> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(userCouponService.getByIdRel(id));
    }

    @ApiOperation("添加")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserCoupon userCoupon) {
        RequestUtil requestUtil = new RequestUtil();
        requestUtil.setTenantId("10559");
        User user = requestUtil.getUserByUnionid(userCoupon.getUnionId());
        if (user != null) {
            userCoupon.setUserId(user.getUserId());
            user.setBalance(user.getBalance().add(new BigDecimal(userCoupon.getBalance())));
            requestUtil.updateUserBalanceWithoutLogin(user);
        }else {
            return fail("用户不存在");
        }
        // 记录当前登录用户id
//        User loginUser = getLoginUser();
//        if (loginUser != null) {
//         userCoupon.setUserId(loginUser.getUserId());
//        }
        if (userCouponService.save(userCoupon)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserCoupon userCoupon) {
        if (userCouponService.updateById(userCoupon)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userCouponService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserCoupon> list) {
        if (userCouponService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserCoupon> batchParam) {
        if (batchParam.update(userCouponService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userCouponService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
